Attribute VB_Name = "intersection"
Global Const EPSILON = 0.000001

'---------------------------------------------------------------------------
' Point en 3D
'---------------------------------------------------------------------------
Public Type Point3
    X As Double
    Y As Double
    Z As Double
End Type

    
'Produit vectoriel
Function VecProd(P1 As Point3, P2 As Point3) As Point3
Dim P4 As Point3

 P4.X = (P1.Y * P2.Z) - (P1.Z * P2.Y)
 P4.Y = (P1.Z * P2.X) - (P1.X * P2.Z)
 P4.Z = (P1.X * P2.Y) - (P1.Y * P2.X)
 VecProd = P4
 
End Function

'Produit Scalaire
Function Dot(p As Point3, q As Point3) As Double
    Dot = p.X * q.X + p.Y * q.Y + p.Z * q.Z
End Function

'Ajout de vecteur
Function VecAdd(P1 As Point3, P2 As Point3, Optional f As Double = 1) As Point3
 Dim P3 As Point3
 P3.X = P1.X + f * P2.X
 P3.Y = P1.Y + f * P2.Y
 P3.Z = P1.Z + f * P2.Z
 VecAdd = P3
End Function

' Soustraction de vecteur
Function VecSub(P1 As Point3, P2 As Point3) As Point3
 VecSub.X = P1.X - P2.X
 VecSub.Y = P1.Y - P2.Y
 VecSub.Z = P1.Z - P2.Z
End Function

'----------------------------------------------------------------------------
' Calcul L'intersection d'un triangle et d'un vecteur
'----------------------------------------------------------------------------
Function Intersect_Paralllogramme_Vecteur(orig As Point3, dir As Point3, Trig_S0 As Point3, Trig_S1 As Point3, Trig_S2 As Point3) As Double

   Dim edge1   As Point3
   Dim edge2   As Point3
   Dim tvec    As Point3
   Dim pvec    As Point3
   Dim qvec    As Point3
   Dim det     As Double
   Dim inv_det As Double
   Dim P_Opp As Point3
   
   Dim T As Double
   Dim U As Double
   Dim V As Double
   

   ' Calcul des deux vecteurs reprsentant les artes partant du point 0 du triangle 1
   'edge1 = VecSub(Trig_S1, Trig_S0)
   edge1.X = Trig_S1.X - Trig_S0.X
   edge1.Y = Trig_S1.Y - Trig_S0.Y
   edge1.Z = Trig_S1.Z - Trig_S0.Z
 
  ' edge2 = VecSub(Trig_S2, Trig_S0)

   edge2.X = Trig_S2.X - Trig_S0.X
   edge2.Y = Trig_S2.Y - Trig_S0.Y
   edge2.Z = Trig_S2.Z - Trig_S0.Z
 
 
   ' Debut par calcul du dterminant aussi utilis pour calculer le paramtre U
   'pvec = VecProd(dir, edge2)
    pvec.X = (dir.Y * edge2.Z) - (dir.Z * edge2.Y)
    pvec.Y = (dir.Z * edge2.X) - (dir.X * edge2.Z)
    pvec.Z = (dir.X * edge2.Y) - (dir.Y * edge2.X)
 
   ' Si le dterminant est dans le mme plan alors le segment et le Paralllogramme sont dans le mme plan
  ' det = Dot(edge1, pvec)
   det = (edge1.X * pvec.X + edge1.Y * pvec.Y + edge1.Z * pvec.Z)
   
   If (det > -EPSILON And det < EPSILON) Then
           GoTo Fin2
   End If
    
   inv_det = 1 / det

   ' Calcule distance entre le sommet 0  l'origine du vecteur
   'tvec = VecSub(orig, Trig_S0)
   tvec.X = orig.X - Trig_S0.X
   tvec.Y = orig.Y - Trig_S0.Y
   tvec.Z = orig.Z - Trig_S0.Z
   ' Calcule le parametre U et test les limites
   'U = Dot(tvec, pvec) * inv_det
   U = (tvec.X * pvec.X + tvec.Y * pvec.Y + tvec.Z * pvec.Z) * inv_det
   If U < 0 Or U > 1 Then
      GoTo Fin
   End If
    
   ' Preparation pour tester le parametre V
   'qvec = VecProd(tvec, edge1)
    qvec.X = (tvec.Y * edge1.Z) - (tvec.Z * edge1.Y)
    qvec.Y = (tvec.Z * edge1.X) - (tvec.X * edge1.Z)
    qvec.Z = (tvec.X * edge1.Y) - (tvec.Y * edge1.X)
 
   ' Calcule le parametre  V et test les limites
   'V = Dot(dir, qvec) * inv_det
   V = (dir.X * qvec.X + dir.Y * qvec.Y + dir.Z * qvec.Z) * inv_det
   
   If V < 0 Or (U + V) > 1 Then
      GoTo Fin
   End If
    
   ' Calcule T, le vecteur intersecte le  triangle
   ' T = Dot(edge2, qvec) * inv_det
   T = (edge2.X * qvec.X + edge2.Y * qvec.Y + edge2.Z * qvec.Z) * inv_det
   If T > 0 Then GoTo Fin2

Fin:
    
   'Calcul avec le deuxime triangle
   ' P_Opp = VecAdd(VecAdd(Trig_S0, edge1), edge2)
  
    P_Opp.X = (Trig_S0.X + edge1.X) + edge2.X
    P_Opp.Y = (Trig_S0.Y + edge1.Y) + edge2.Y
    P_Opp.Z = (Trig_S0.Z + edge1.Z) + edge2.Z
 
   'Calcul des deux vecteurs reprsentant les artes partant du point 0 du triangle 2
   ' Calcule distance entre le sommet 0  l'origine du vecteur
   'tvec = VecSub(orig, P_Opp)
    tvec.X = orig.X - P_Opp.X
    tvec.Y = orig.Y - P_Opp.Y
    tvec.Z = orig.Z - P_Opp.Z

   ' Calcule le parametre U et test les limites
   'U = Dot(tvec, pvec) * inv_det
   
   U = (tvec.X * -pvec.X - tvec.Y * pvec.Y - tvec.Z * pvec.Z) * inv_det
   If U < 0 Or U > 1 Then
      GoTo Fin2
   End If
    
   ' Preparation pour tester le parametre V
   'qvec = VecProd(tvec, edge1)
    qvec.X = (tvec.Z * edge1.Y) - (tvec.Y * edge1.Z)
    qvec.Y = (tvec.X * edge1.Z) - (tvec.Z * edge1.X)
    qvec.Z = (tvec.Y * edge1.X) - (tvec.X * edge1.Y)
 
   ' Calcule le parametre  V et test les limites
   'V = Dot(dir, qvec) * inv_det
   V = (dir.X * qvec.X + dir.Y * qvec.Y + dir.Z * qvec.Z) * inv_det
   
   If V < 0 Or (U + V) > 1 Then
      GoTo Fin2
   End If
    
   ' Calcule T, le vecteur intersecte le  triangle
   ' T = Dot(edge2, qvec) * inv_det
   T = (-edge2.X * qvec.X - edge2.Y * qvec.Y - edge2.Z * qvec.Z) * inv_det
    

Fin2:

    Intersect_Paralllogramme_Vecteur = T
End Function



